## sikuli 1.0~x~rc2

=== extensions/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT (sikuli-extensions Java)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/")
INCLUDE(${CMAKE_MODULE_PATH}/common.cmake)
FIND_PACKAGE(Java)

SET(BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
SET(COMMON_LIB_DIR "${BASE_DIR}/../lib")

SET(SIKULI_JAR ${COMMON_LIB_DIR}/sikuli-script.jar)
SET(CLASSPATH ${SIKULI_JAR})


### add new extensions here
SET(EXTENSIONS 
   guide
)

FOREACH(EXT ${EXTENSIONS})
   ADD_SUBDIRECTORY(${EXT})
ENDFOREACH(EXT)
