## sikuli 1.0~x~rc2-dfsg1

=== debian/changelog ===
sikuli (1.0~x~rc2-dfsg1-2ubuntu1) oneiric; urgency=low

  * debian/rules: fix multiarch-related FTBFS.

 -- Ilya Barygin <barygin@gmail.com>  Sun, 14 Aug 2011 18:09:12 +0400

sikuli (1.0~x~rc2-dfsg1-2) unstable; urgency=low

  * debian/control, debian/copyright:
    + Fix pkg-java-maintainers address. 
  * debian/copyright:
    + Update to DEP5 format specification rev174

 -- Gilles Filippini <pini@debian.org>  Sat, 16 Apr 2011 12:48:15 +0200

sikuli (1.0~x~rc2-dfsg1-1) unstable; urgency=low

  * New upstream release:
    + Redesigned user interface for Sikuli-IDE
    + Support for extensions for Sikuli Script

  * debian/control, debian/copyright:
    The package is now maintained by the Debian Java maintainers Team

 -- Gilles Filippini <pini@debian.org>  Sat, 16 Apr 2011 00:23:53 +0200

sikuli (1.0~x~rc1-dfsg1-2) unstable; urgency=low

  * debian/control: enforce java6 dependency using a versioned [Build-]Depends
    against default-jdk and default-jre (>= 1:1.6) instead of depending on
    java6-sdk and java6-runtime. 

 -- Gilles Filippini <pini@debian.org>  Mon, 24 Jan 2011 01:07:30 +0100

sikuli (1.0~x~rc1-dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #578125)

 -- Gilles Filippini <pini@debian.org>  Thu, 20 Jan 2011 22:37:52 +0100
