=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh --with javahelper $@ 

override_dh_auto_configure:
	# Time stamp to prevent re-generation
	touch ./sikuli-script/src/main/native/org_sikuli_script_VDictProxy.h

override_dh_auto_clean:
	rm -fr \
		sikuli-script/build \
		sikuli-script/target/*.jar \
		sikuli-script/target/classes \
		sikuli-script/target/lib \
		sikuli-script/target/jar \
		sikuli-script/doc \
		sikuli-ide/build \
		sikuli-ide/target/*.jar \
		sikuli-ide/target/classes \
		sikuli-ide/target/linux/Sikuli-IDE/*.jar \
		sikuli-ide/target/linux/Sikuli-IDE/classes \
		sikuli-ide/target/linux/Sikuli-IDE/libs \
		sikuli-ide/target/jar \
		lib
	dh_auto_clean

override_dh_auto_build:
	mkdir sikuli-script/build sikuli-ide/build
	cd sikuli-script/build && \
                cmake -D CMAKE_LIBRARY_ARCHITECTURE=$(DEB_HOST_MULTIARCH) ..
	make -C sikuli-script/build
	cd sikuli-ide/build && cmake ..
	make -C sikuli-ide/build app
	javadoc -windowtitle "Javadoc of Sikuli Script" -sourcepath sikuli-script/src/main/java:sikuli-script/build -d sikuli-script/doc/ -classpath lib:/usr/share/java/jython.jar \
		-link /usr/share/doc/default-jdk-doc/api \
		-link /usr/share/doc/jython-doc/api-html \
		-link /usr/share/doc/junit-doc/doc/api \
		-link /usr/share/doc/libswing-layout-java-doc/api \
		-link /usr/share/doc/libjxgrabkey-java/api \
		org.sikuli.script

override_jh_build:
	# no-op

override_dh_install:
	mkdir -p debian/libsikuli-script-java/usr/bin
	install sikuli-script/target/sikuli-script.sh debian/libsikuli-script-java/usr/bin/sikuli
	
	mkdir -p debian/sikuli-ide/usr/bin
	install sikuli-ide/target/linux/Sikuli-IDE/sikuli-ide.sh debian/sikuli-ide/usr/bin/sikuli-ide
	
	dh_install
