=== sikuli-script/src/main/native/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# Copyright 2010-2011, Sikuli.org
+# Released under the MIT License.
 ENABLE_LANGUAGE(CXX)
 
 IF(LINUX)
@@ -16,6 +18,7 @@
    org_sikuli_script_VDictProxy.h
    org_sikuli_script_Win32Util.h
    org_sikuli_script_MacUtil.h
+   org_sikuli_script_internal_hotkey_MacHotkeyManager.h
 )
 
 SET(LIBRARY_OUTPUT_PATH ${BINARY_LIB_DIR})
@@ -30,11 +33,15 @@
 INCLUDE(${SWIG_USE_FILE})
 
 # profiling
-#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_TIMING")
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_TIMING")
 # visual logger for debugging
-#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_VISUAL_LOG")
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_VISUAL_LOG")
 # OCR matching debug
-#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_OCR_DEBUG")
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_OCR_DEBUG")
+# enable the debug message in finder
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG_FINDER")
+# use GPU in template matcher
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_GPU")
 
 IF(NOT WIN32)
    FIND_PACKAGE(Tesseract REQUIRED)
@@ -68,9 +75,10 @@
 SET(CMAKE_SWIG_FLAGS -package ${NATIVE_PACKAGE})
 SET(SWIG_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
 
-IF(LINUX)
+IF(LINUX OR APPLE)
    FIND_LIBRARY(TIFF_LIBS NAMES tiff)
    LIST(APPEND OpenCV_LIBS ${TIFF_LIBS})
+   LINK_DIRECTORIES(${TIFF_LIB_DIR})
 ENDIF()
 
 SET(BUILD_TARGETS
@@ -88,6 +96,7 @@
    TARGET_LINK_LIBRARIES(Win32Util ${JAVA_AWT_LIBRARY})
 ENDIF()
 
+
 IF(APPLE)
    LIST(APPEND BUILD_TARGETS MacUtil)
    FIND_LIBRARY(JAVA_LIBRARY JavaVM)
@@ -101,17 +110,28 @@
       org_sikuli_script_MacUtil.h
    )
    TARGET_LINK_LIBRARIES(MacUtil ${EXTRA_LIBS})
+
+   LIST(APPEND BUILD_TARGETS MacHotkeyManager)
+
+   ADD_LIBRARY(MacHotkeyManager SHARED
+      MacHotkeyManager.cc
+      sikuli-debug.cpp
+      org_sikuli_script_internal_hotkey_MacHotkeyManager.h
+   )
+   TARGET_LINK_LIBRARIES(MacHotkeyManager ${EXTRA_LIBS})
 ENDIF()
 
 SET(NATIVE_LIBS
    VisionProxy
    ${BUILD_TARGETS}
 )
+message("NATIVE_LIBS: ${NATIVE_LIBS}")
 
 ADD_LIBRARY(VDictProxy SHARED
    VDictProxy.cc
    org_sikuli_script_VDictProxy.h
 )
+TARGET_LINK_LIBRARIES(VDictProxy ${OpenCV_LIBS})
 
 
 ## SWIG: generate a JNI wrapper 
@@ -148,14 +168,10 @@
 
 foreach(BUILD_TARGET ${BUILD_TARGETS})
    TARGET_LINK_LIBRARIES(${BUILD_TARGET} ${OpenCV_LIBS})
-   if(APPLE)
-      set_target_properties(${BUILD_TARGET} PROPERTIES SUFFIX ".jnilib")
-   endif(APPLE)
+   add_dependencies(${BUILD_TARGET} ${PROJECT_NAME}.classes)
+   IF(APPLE)
+      SET_TARGET_PROPERTIES(${BUILD_TARGET} PROPERTIES SUFFIX ".jnilib")
+   ENDIF(APPLE)
 endforeach(BUILD_TARGET ${BUILD_TARGETS})
 
-add_custom_target(${JAR_FILE}.libs-in-jar
-   COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_DIR}/META-INF
-   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_LIB_DIR} ${JAR_DIR}/META-INF/lib
-)
-
 add_dependencies(${JAR_FILE}.libs-in-jar ${NATIVE_LIBS})
